$!   Note that description info is at end of file to speed DCL processing
$!
$!      Get file name of source to be edited
$WHO=F$EDIT(F$GETJPI("","USERNAME"),"TRIM")
$OSQFILE:='P1'
$!      Check to see if file exists
$TSTFILE=F$SEARCH(P1)
$IF TSTFILE.NES."" THEN $GOTO OKFILE
$!
$!      File does not exist so create new blank file
$OPEN /WRITE INPUT_FILE 'P1'
$WRITE INPUT_FILE " "
$CLOSE INPUT_FILE
$TSTFILE=F$SEARCH(P1)
$!
$OKFILE:
$!	Split source file name into constituent parts
$XNODE=F$PARSE(TSTFILE,,,"NODE")
$XDEVICE=F$PARSE(TSTFILE,,,"DEVICE")
$XDIRECTORY=F$PARSE(TSTFILE,,,"DIRECTORY")
$XNAME=F$PARSE(TSTFILE,,,"NAME")
$XTYPE=F$PARSE(TSTFILE,,,"TYPE")
$XVERSION=F$PARSE(TSTFILE,,,"VERSION")
$!
$!      Remember default directory  
$DEFAULT_DIR=F$ENVIRONMENT("DEFAULT")
$!      Make file's directory the default
$SET DEFAULT 'XNODE''XDEVICE''XDIRECTORY'
$!
$!      Initialise number of include files found in source to 0
$INCLUDES=0
$IF XTYPE.NES.".OSQ" THEN $GOTO NOTOSQ
$!
$!	Build the filename we will use in the editor
$OSQEDIT:='XNODE''XDEVICE''XDIRECTORY''XNAME'".EDT"
$!
$!      Set up foreign commands for converting file
$! **** put the correct path here! ****
$OSQCONVERT=="$USERS:[DEVELOPER.UTILITY]OSQEDIT.EXE"
$!
$!	Run the conversion program to remove any expanded macros etc.
$OSQCONVERT E 'OSQFILE' 'OSQEDIT'
$
$!	Remember the last revision date of the file to be edited
$LASTREV=F$FILE_ATTRIBUTES(OSQEDIT,"RDT")
$!
$!	Convert any include filenames in symbols I1..In to logicals of same name
$!	Start with 0
$ICOUNT=0
$INCLOOP:
$!	Any more to process?
$IF INCLUDES.EQ.ICOUNT THEN $GOTO NOINCLUDES
$!	Next one
$ICOUNT=ICOUNT+1
$!	Compute its name
$INAME=I'ICOUNT'
$!	Define the logical
$DEFINE I'ICOUNT' 'INAME' /NOLOG
$!	Add the revision date of the include file to list of revision dates
$LASTREV=LASTREV+F$FILE_ATTRIBUTES(INAME,"RDT")
$!	And loop
$GOTO INCLOOP
$
$NOINCLUDES:
$
$!	Edit the file
$DEFINE SYS$INPUT SYS$OUTPUT /USER /NOLOG
$IF TSTFILE.EQS."" THEN ED 'OSQFILE'
$IF TSTFILE.NES."" THEN ED 'OSQEDIT'
$
$!	Get the revision of the file after editing
$ENDREV=F$FILE_ATTRIBUTES(OSQEDIT,"RDT")
$!
$!	Get the revision date of the include files after editing
$!	Start with 0
$ICOUNT=0
$INCLOOP2:
$!	Any more to process?
$IF INCLUDES.EQ.ICOUNT THEN $GOTO NOINCLUDES2
$!
$!	Next one
$ICOUNT=ICOUNT+1
$!
$!	Compute its name
$INAME=I'ICOUNT'
$!
$!	Add the revision date of the include file to list of revision dates
$ENDREV=ENDREV+F$FILE_ATTRIBUTES(INAME,"RDT")
$!	And loop
$GOTO INCLOOP2
$
$NOINCLUDES2:
$!	Have any of the revison dates changed?
$!	If none have changed no need to reexpand macros 
$!      since .OSQ file has not changed
$IF LASTREV.EQS.ENDREV THEN $GOTO ALLEXIT
$
$!	Otherwise expand macros and save in OSQ file again
$OSQCONVERT S 'OSQEDIT' 'OSQFILE'
$
$!	And exit
$GOTO ALLEXIT
$
$!	Edit normal files here
$NOTOSQ:
$DEFINE SYS$INPUT SYS$OUTPUT /USER /NOLOG
$ED 'P1'
$
$!	Common exit point
$ALLEXIT:
$SET DEFAULT 'DEFAULT_DIR'
$EXIT
$! *************************************************************************
$!               Driver program for macro editor 05/15/92 V2.0 VMS 5.4
$!	         By Mark C. Jones 
$!
$!	            Program will automatically remove expanded macros from
$!	         any file prior to editing and automatically replaces them
$!	         after editing file. Default directory is changed to the
$!               directory of the file being edited. Symbols I1-In are
$!               created that are the names of all distinct macros found
$!               in the source file.
$!
$!                  The editor invoked is the editor defined as ED.
$!               To use macro editor as Ingres default editor use the following
$!               lines of code: 
$!                $OSQED=="@DISK:[DIRECTORY]OSQED.COM"
$!                $DEFINE ING_EDIT OSQED  
$! *************************************************************************
$
                                   NO WARRANTY

     BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO
     WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE
     LAW.  EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT
     HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM ``AS IS''
     WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED,
     INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
     MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE
     ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS
     WITH YOU.  SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE
     COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.

     IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
     WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY
     MODIFY AND/OR REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE
     LIABLE TO YOU FOR DAMAGES, INCLUDING ANY GENERAL, SPECIAL,
     INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR
     INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED TO LOSS
     OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY
     YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH
     ANY OTHER PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN
     ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.

     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 
